<template>
    <div>
        <template
            v-if="action === 0"
        >
            <div
                class="text-center font-bold text-lg mx-auto w-full my-6"
            >
                {{ $t('select_an_action' )}}
            </div>
            <div
                class="text-center mx-auto w-full"
            >
                <div>{{ $t('withdrawal_of_unrealized_roi') }}</div>
                <div
                    class="text-red-500 text-xs"
                >
                    {{ $t('withdrawal_of_unrealized_roi_admin_fees_note') }}
                </div>
                <div
                    class="px-4 pt-2"
                >
                    <div
                        class="cursor-pointer bg-purple-600 text-white font-bold text-center uppercase cursor-pointer w-full px-4 py-3 rounded-sm"
                        @click="action = 1"
                    >
                        {{ $t('unrealized_roi_withdrawal') }}
                    </div>
                </div>
            </div>
            <div
                class="text-center mx-auto w-full mt-6"
            >
                <div>{{ $t('early_capital_withdrawal') }}</div>
                <div
                    class="text-red-500 text-xs"
                >
                    {{ $t('early_capital_withdrawal_admin_fees_note') }}
                </div>
                <div
                    class="px-4 pt-2"
                >
                    <div
                        class="cursor-pointer bg-purple-600 text-white font-bold text-center uppercase cursor-pointer w-full px-4 py-3 rounded-sm"
                        @click="action = 2"
                    >
                        {{ $t('early_capital_withdrawal') }}
                    </div>
                </div>
            </div>
        </template>
        <template
            v-else-if="action === 1"
        >
            <div>
                <div
                    class="font-black text-left capitalize"
                >
                    {{ $t('unrealized_roi_withdraw_amount') }}
                </div>
                <form-input
                    v-model="withdrawAmount"
                    type="number"
                    name="withdraw_amount"
                    hide-label
                    dollar-sign dark
                    fund
                    :errors="errors && errors.withdraw_amount ? errors.withdraw_amount : null"
                    size="lg"
                />
                <div class="text-left">{{ $t('unrealized_roi_balance') }}: {{ $helper.fundFormat(investment.roi_balance) }}</div>
                <div class="text-left text-red-500">{{ $t('withdrawn_realized_roi') }}: {{ $helper.fundFormat(Math.abs(investment.withdrawn_amount)) }}</div>
            </div>
            <div
                class="mt-4"
            >
                <div
                    class="font-black text-left capitalize"
                >
                    {{ $t('password2') }}
                </div>
                <form-pin
                    v-model="password2"
                    name="current_password2"
                    hide-label
                    dark
                    fund
                    :errors="errors && errors.current_password2 ? errors.current_password2 : null"
                    size="lg"
                />
            </div>
            <div
                class="mt-4 flex justify-start items-start space-x-2 text-left cursor-pointer"
                @click="agree === 1 ? agree = 0 : agree = 1"
            >
                <div>
                    <font-awesome-icon
                        v-if="agree === 0"
                        icon="fas fa-square"
                        size="2x"
                    />
                    <font-awesome-icon
                        v-else-if="agree === 1"
                        icon="fas fa-check-square"
                        size="2x"
                    />
                </div>
                <div
                    class="flex-1"
                >
                    {{ $t('hereby_i_agree_unrealized_roi_early_withdrawal_terms') }}
                </div>
            </div>
            <div
                v-if="agree === 1"
                class="cursor-pointer bg-purple-600 text-white font-bold text-center uppercase cursor-pointer w-full px-4 py-3 rounded-sm tracking-wider mt-4"
                :class="{
                    'bg-opacity-50 cursor-wait': busy
                }"
                @click="confirmSubmitForm"
            >
                {{ $t('confirm') }}
            </div>
        </template>
        <template
            v-else-if="action === 2"
        >
            <div>
                <div
                    class="font-black text-left capitalize"
                >
                    {{ $t('capital_early_withdrawal_amount') }}
                </div>
                <form-input
                    v-model="capitalWithdrawAmount"
                    type="number"
                    name="capital_withdraw_amount"
                    hide-label
                    dollar-sign dark
                    fund
                    readonly disabled
                    :errors="errors && errors.capital_withdraw_amount ? errors.capital_withdraw_amount : null"
                    size="lg"
                />
            </div>
            <div
                class="mt-4"
            >
                <div
                    class="font-black text-left capitalize"
                >
                    {{ $t('unrealized_roi_forfeited') }}
                </div>
                <form-input
                    v-model="unrealizedRoiForfeited"
                    type="number"
                    name="unrealized_roi_forfeited"
                    hide-label
                    dollar-sign dark
                    fund
                    readonly disabled
                    :errors="errors && errors.unrealized_roi_forfeited ? errors.unrealized_roi_forfeited : null"
                    size="lg"
                />
            </div>
            <div
                class="mt-4"
            >
                <div
                    class="font-black text-left capitalize"
                >
                    {{ $t('password2') }}
                </div>
                <form-pin
                    v-model="password2"
                    name="current_password2"
                    hide-label
                    dark
                    fund
                    :errors="errors && errors.current_password2 ? errors.current_password2 : null"
                    size="lg"
                />
            </div>
            <div
                class="mt-4 flex justify-start items-start space-x-2 text-left cursor-pointer"
                @click="agree === 1 ? agree = 0 : agree = 1"
            >
                <div>
                    <font-awesome-icon
                        v-if="agree === 0"
                        icon="fas fa-square"
                        size="2x"
                    />
                    <font-awesome-icon
                        v-else-if="agree === 1"
                        icon="fas fa-check-square"
                        size="2x"
                    />
                </div>
                <div
                    class="flex-1"
                >
                    {{ $t('hereby_i_agree_capital_early_withdrawal_terms') }}
                </div>
            </div>
            <div
                v-if="agree === 1"
                class="cursor-pointer bg-purple-600 text-white font-bold text-center uppercase cursor-pointer w-full px-4 py-3 rounded-sm tracking-wider mt-4"
                :class="{
                    'bg-opacity-50 cursor-wait': busy
                }"
                @click="confirmSubmitForm"
            >
                {{ $t('confirm') }}
            </div>
        </template>
    </div>
</template>

<script setup>
import {ref, computed, onMounted} from "vue";
import axios from "axios";
import FormInput from "~/components/form/form-input.vue";
import FormPin from "~/components/form/form-pin.vue";
import {FontAwesomeIcon} from "@fortawesome/vue-fontawesome";

const props = defineProps({
    plan: {
        required: true,
        type: Object,
    },
    investment: {
        required: true,
        type: Object
    }
});
const emit = defineEmits(['close']);

const action = ref(0);
const errors = ref({});
const withdrawAmount = ref('');
const capitalWithdrawAmount = ref('');
const unrealizedRoiForfeited = ref('');
const password2 = ref('');
const agree = ref(0);
const busy = ref(false);

onMounted(() => {
    capitalWithdrawAmount.value = props.investment.current_balance;
    unrealizedRoiForfeited.value = props.investment.roi_balance;
});

const confirmSubmitForm = async () => {
    if (!busy.value) {
        try {
            busy.value = true;

            if (action.value === 1) {
                //WITHDRAW ROI
                const data = await axios.post(`/portfolio/withdraw_roi/${props.investment.contract_id}`, {
                    withdraw_roi_amount: withdrawAmount.value,
                    capital_withdraw_amount: capitalWithdrawAmount.value,
                    password2: password2.value
                });

                emit('close');
            } else if (action.value === 2) {
                //WITHDRAW CAPITAL
                const data = await axios.post(`/portfolio/withdraw_capital/${props.investment.contract_id}`, {
                    capital_withdraw_amount: capitalWithdrawAmount.value,
                    password2: password2.value
                });

                emit('close', true);
            }
        } catch (e) {
            console.log(e);
        } finally {
            busy.value = false;
        }
    }
};
</script>
